//**************************************************************
// WILDCAT GRAV CYCLE - MeBaD
//**************************************************************

//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

datablock HoverVehicleData(MeBaDGravVehicle) : WildcatDamageProfile
{
   spawnOffset = "0 0 1";

   floatingGravMag = 5; // was 3.5 - was 4 in 1.1

   catagory = "Vehicles";
   shapeFile = "vehicle_grav_scout_Nova.dts";
   computeCRC = true;

   debrisShapeName = "vehicle_grav_scout_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag = 0.0;
   density = 0.9;

   mountPose[0] = scoutRoot;
   cameraMaxDist = 6.0;
   cameraOffset = 0.7;
   cameraLag = 0.5;
   numMountPoints = 0.7;
   isProtectedMountPoint[0] = true;
   explosion = VehicleExplosion;
	explosionDamage = 0.5;
	explosionRadius = 5.0;

   lightOnly = 0;

   maxDamage = 0.60;
   destroyedLevel = 0.60;

   isShielded = true;
   rechargeRate = 1;
   energyPerDamagePoint = 75;
   maxEnergy = 150;
   minJetEnergy = 15;
   jetEnergyDrain = 1.3;

   // Rigid Body
   mass = 400;
   bodyFriction = 0.1;
   bodyRestitution = 0.5;  
   softImpactSpeed = 500;       // Play SoftImpact Sound
   hardImpactSpeed = 800;      // Play HardImpact Sound

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 29;
   speedDamageScale = 0.008;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 22; // was 23 (24 in 1.0)
   collDamageMultiplier   = 0.030; // was 0.030

   dragForce            = 25 / 45.0; // was 23 / 45.0
   vertFactor           = 0.0;
   floatingThrustFactor = 0.60; // was 0.35

   mainThrustForce    = 30;
   reverseThrustForce = 10;
   strafeThrustForce  = 8;
   turboFactor        = 3.5;
   NOSFactor          = 20000;
   NOSCounter         = 5;

   brakingForce = 25;
   brakingActivationSpeed = 4;

   stabLenMin = 2.25;
   stabLenMax = 3.75;
   stabSpringConstant  = 30;
   stabDampingConstant = 16;

   gyroDrag = 16;
   normalForce = 30;
   restorativeForce = 40; // was 20 (version 1.1x)
   steeringForce = 38; // was 40 (version 1.1x)
   rollForce  = 27; // was 15 (version 1.1x)
   pitchForce = 8; // was 7 (version 1.1x)

   dustEmitter = VehicleLiftoffDustEmitter;
//   dustEmitter = MissileSmokeEmitter;
   triggerDustHeight = 2.5;
   dustHeight = 1.0;
//   dustTrailEmitter = TireEmitter;
   dustTrailEmitter = MissileSmokeEmitter;
   dustTrailOffset = "0.0 -1.0 0.5";
   triggerTrailHeight = 3.6;
   dustTrailFreqMod = 15.0;

//   jetSound         = ScoutSqueelSound;
   jetSound         = HAPCFlyerThrustSound;
   engineSound      = ScoutEngineSound;
   floatSound       = ScoutThrustSound;
   softImpactSound  = GravSoftImpactSound;
   hardImpactSound  = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;

   //
   softSplashSoundVelocity = 10.0; 
   mediumSplashSoundVelocity = 20.0;   
   hardSplashSoundVelocity = 30.0;   
   exitSplashSoundVelocity = 10.0;
   
   exitingWater      = VehicleExitWaterSoftSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterSoftSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeSoftSplashSound; 

   minMountDist = 4;

   damageEmitter[0] = SmallLightDamageSmoke;
   damageEmitter[1] = SmallHeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -1.5 0.5 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;
   
//   forwardJetEmitter = WildcatJetEmitter;
//   forwardJetEmitter = ContrailEmitter; // long trail
//     forwardJetEmitter = MissileSmokeEmitter; // smoke trail
	forwardJetEmitter = NovaGravEmitter;

   cmdCategory = Tactical;
   cmdIcon = CMDHoverScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_landscout_grey";
   targetNameTag = 'Nova';
   targetTypeTag = 'Cycle';
   sensorData = VehiclePulseSensor;

   checkRadius = 1.7785;
   observeParameters = "1 15 15";

   runningLight[0] = WildcatLight1;
   runningLight[1] = WildcatLight2;
   runningLight[2] = WildcatLight3;

   shieldEffectScale = "0.9375 1.125 0.6";
};

//**************************************************************
// WEAPONS
//**************************************************************